# Created: <2005/06/02>

use XML::DOM;
use Jcode;

$| = 1;

# 出力文字セット
local $out_charset = "sjis";
# 入力文字セット
local $in_charset = "utf8";

my $datafile = "reference.xml";
my $outfile = "lisp";

# Parse XML
print STDOUT "$0: parsing $datafile ... ";
my $parser = new XML::DOM::Parser;
my $doc = $parser->parsefile( $datafile);
print STDOUT "done.\n";

# 索引用
my @arrfunc = ();
my @arrkey = ();
my @arrvar = ();

sub writeln {
	my $strbuf = sprintf(scalar(shift), @_);
	print OUT Jcode::convert($strbuf, $out_charset, $in_charset), "\n";
}


# 出力ファイルオープン
open( OUT, ">$outfile") || die "Could not open $outfile: $!";

# データをハッシュに
print STDOUT "$0: studying data ... ";

# <book>
for my $book ( $doc->getChildNodes) {
	# <chapter>
	for my $chapter ( $book->getChildNodes){
		if ($chapter -> getNodeType == ELEMENT_NODE) {
			for my $elem ( $chapter->getChildNodes){
				if ($elem -> getNodeType == ELEMENT_NODE) {
					$dd = $elem -> getNodeName;
					if ($dd eq "title") {
						for my $txt ($elem -> getChildNodes) {
							if ($txt -> getNodeType == TEXT_NODE) {
								$title = $txt -> getData;
							}
						}
					} elsif ($dd eq "type") {
						for my $txt ($elem -> getChildNodes) {
							if ($txt -> getNodeType == TEXT_NODE) {
								$type = $txt -> getData;
							}
						}
					}
				}
			}
			if ($type eq "Function" || $type eq "Special Form" || $type eq "Macro" || $type eq "Misc" || $type eq "Accessor") {
				push (@arrfunc, $title);
			} elsif ($type eq "Variable" || $type eq "BufferLocal" || $type eq "Keyword") {
				push (@arrvar, $title);
			}
			# それ以外のタイプは出力されない
		}
	} # <chapter>
}


for $i (sort @arrfunc) {
	writeln "$i";
}

writeln ";*2";

for $i (sort @arrvar) {
	writeln "$i";
}


close ( OUT);
print STDOUT "done.\n";
exit;
